/* $Id: jp.java,v 1.126 2013/10/22 06:32:25 mit Exp $ */
/* jp.java v2.9 */
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.text.DecimalFormat;

public class jp extends Applet
    implements ItemListener, ActionListener, AdjustmentListener,
    MouseListener, MouseMotionListener, Runnable
{
    static final int KB = 88;
    static final int Oct = 12;
    static final int WAVE = 0;      // GRAP wave
    static final int FFT_ = 1;      // " fft 
    static final int PEAK = 2;      // " peak
    static final int INHA = 3;      // " inharmo.
    static final int DIFF = 4;      // " diff
    static final int CENT = 5;      // " cent
    static final int MinIH = 10;    // diff min(0.1)
    static final int MaxIH = 70;    // diff max(0.7)
    static final double SMaxVal = Short.MAX_VALUE;
    static final String[] Dev = {"1/1", "1/2", "1/4", "1/8", "1/16"};
    static final String[] Graps = {"Wave","FFT_","Peak","Inha."};
    static final String[] Keynm =
    {"A..","B..","H..","C..","Cis","D..","Es.","E..","F..","Fis","G..","Gis"};
    static final String[] Spnm = {"9","10","11","12","13","14"}; 
    private static final long serialVersionUID = 1L;

    boolean CALC;
    boolean IHsw;
    boolean GTsw;      // graph./text
    boolean Msw;       // mouse click
    boolean AutoSW;    // auto/manu sw.
    boolean DragSW;
    boolean FftSW;
    boolean WaveSW;
    int FNT;           // font size
    int AF;            // all_file_num.
    int GRAP;          // graph. select
    int Splngf;        // data sampling frq.
    int Sph;           // Splngf/2 ()
    int WaveDataN;     // wave ǡ
    int Cnt;           // wave ɽϰϿ
    int Start;         // wave ɽϰ
    int Firstx, Lastx; // for mouse dragg
    int Firstp, Lastp; // FFT åϰ
    int NB = 12;       // n (9:512 10:1024 11:2048 12:4096 13: 14:)
    int NN;            // 2^n
    int N2;            // NN/2 (fft)
    int Xby;           // xΨ(2)
    int PeakLimit;     // peak clip
    int MX;            // mouse x
    int Cmax;          // inh. cent max
    int KEY;
    int Level;         // åԥ
    int ValIH;         // for diff
    int FftCnt;
    int WaveCnt;
    double Wdf;        // (W-1)/(Sph/Xby)
    double Wdn;        // (W-1)/(N2/Xby)
    double Wby;        // wave gain
    double Yby;        // fft gain
    double Ymax;       // fft max 
    double CX;         // cent x2  
    double Vnum;       // Hsft/Frame
    double Vsize;      // splng_v
    double Dwave;      // W/Cnt 
    double Cby;        // ih.cent
    int[] Wdat;        // all wave data
    String[] Filenm;
    String Error;
    String Dirnm;
    String AFormat;

    CalcPitch CP;
    DecimalFormat df1, df2;
    Graphics gi;
    Image ig;
    Font Fnt, Fns;
    FontMetrics fm;

    private Choice chFile;       // wave files
    private Choice chSmpl;       // ץ󥰿
    private Choice chDevid;
    private TextField tfA;       // error etc.
    private Button btGO;         // go
    private Button btCX;         // cent x2
    private Button btCZ;         // cent /2
    private Button[] btGrap;
    private Button btTX;         // grap/text
    private Button btP, btM;     // +,-
    private Button btW, btN;     // >,<
    private Button btAuto;
    private Scrollbar scrKey;    // limit etc.
    private Scrollbar scrWide;   // for wave 
    private Scrollbar scrVert;
    private Canvas canA;
    private TextArea taA;
    private Panel deck;
    private CardLayout Card;
    private Thread thr;
    private Panel Pn, Ps, Pe, Pw;

    public void init() {
	String fnt = getParameter("font");
        FNT = (fnt != null) ? Integer.parseInt(fnt) : 12;
	Fnt = new Font("SansSerif", Font.PLAIN, FNT);
	Fns = new Font("SansSerif", Font.PLAIN, FNT);
	setFont(Fnt);
	fm = getFontMetrics(Fnt);

	df1 = new DecimalFormat("#0.0##");
	df2 = new DecimalFormat("#0.0#");

	buildLayout();
    }
    public void buildLayout() {
        setBackground(Color.lightGray);
        setLayout(new BorderLayout());

	deck = new Panel();
        Card = new CardLayout();
        deck.setLayout(Card);
	//-----------south

	Ps = new Panel();
        Ps.setLayout(new GridLayout(2,2,0,0));
        add(Ps, "South");

	scrKey = new Scrollbar(Scrollbar.HORIZONTAL, 0,0,0,0);
	scrKey.setBlockIncrement(2);
	scrKey.addAdjustmentListener(this);
        Ps.add(scrKey);

	Ps.add(new Label(": Key"));
	Ps.add(new Label("Wide :", Label.RIGHT));

	scrWide = new Scrollbar(Scrollbar.HORIZONTAL, 0,0,0,0);
	scrWide.addAdjustmentListener(this);
	Ps.add(scrWide);
	//-------------north

	Pn = new Panel();
	Pn.setLayout(new GridLayout(2,1,0,0));
	add(Pn, "North");

	Panel n0 = new Panel();
	n0.setLayout(new FlowLayout());
	Pn.add(n0);

	n0.add(new Label("JP "));

	tfA = new TextField(35); //
	tfA.setFont(Fns);
        tfA.setForeground(Color.blue);
        tfA.setEditable(false);
        n0.add(tfA);
	//---

	Panel n1 = new Panel();
	n1.setLayout(new FlowLayout());
	Pn.add(n1);

	btGO = new Button(" GO ");
        btGO.addActionListener(this);
        n1.add(btGO);

	n1.add(new Label("  "));

	String fn = getParameter("all_f");
        AF = (fn == null) ? 0 : Integer.parseInt(fn);
	if (AF == 0)
            Error = "No wave file.";
        Filenm = new String[AF];
	Dirnm = getParameter("dirnm");
        Dirnm = (Dirnm == null) ? "" : Dirnm;
	chFile = new Choice();
        for (int i = 0; i < AF; i++) {
            Filenm[i] = getParameter("wave"+i);
	    chFile.addItem(Filenm[i]);
	}       
	n1.add(chFile);
        chFile.addItemListener(this);

	n1.add(new Label("  "));

	chSmpl = new Choice();          // NN
        for (int i = 0; i < Spnm.length; i++)
            chSmpl.addItem(Spnm[i]);
        n1.add(chSmpl);
        chSmpl.addItemListener(this);
	chSmpl.select(""+NB);         // 

	chDevid = new Choice();
        for (int i = 0; i < Dev.length; i++)
            chDevid.addItem(Dev[i]);
        n1.add(chDevid);
        chDevid.addItemListener(this);

	n1.add(new Label("  "));

	btCZ = new Button("C/");
        btCZ.addActionListener(this);
        n1.add(btCZ);

	btCX = new Button("Cx");
        btCX.addActionListener(this);
        n1.add(btCX);
	//-----------east
	
	Pe = new Panel();
	Pe.setLayout(new GridLayout(1,2,0,0));
	add(Pe, "East");

	Panel e1 = new Panel();
	e1.setLayout(new GridLayout(1,1,0,0));
	Pe.add(e1);

	scrVert = new Scrollbar(Scrollbar.VERTICAL, 0,1,0,100);
	scrVert.addAdjustmentListener(this);
	e1.add(scrVert);

	Panel e2 = new Panel();
	e2.setLayout(new GridLayout(5,1,0,0));
	Pe.add(e2);

        btP = new Button("+");
        btP.addActionListener(this);
        e2.add(btP);

	btM = new Button("-");
        btM.addActionListener(this);
        e2.add(btM);

	e2.add(new Label(""));

	btN = new Button("<");
        btN.addActionListener(this);
        e2.add(btN);

	btW = new Button(">");
        btW.addActionListener(this);
        e2.add(btW);
	//----------west

	Pw = new Panel();
	Pw.setLayout(new GridLayout(Graps.length+2,1,0,0));
        add(Pw, "West");

	btGrap = new Button[Graps.length];
	for (int i = 0; i < Graps.length; i++) {
	    btGrap[i] = new Button(Graps[i]);
	    btGrap[i].addActionListener(this);
	    Pw.add(btGrap[i]);
	}

	btTX = new Button("Grap.");
        btTX.addActionListener(this);
        Pw.add(btTX);

	btAuto = new Button("Auto.");
        btAuto.addActionListener(this);
        Pw.add(btAuto);
	//-------center

	canA = new MyCanvas();

	Panel g = new Panel();
        g.add(canA);
        deck.add(g, "graph");

        taA = new TextArea("", 15, 47, TextArea.SCROLLBARS_BOTH);
	taA.setFont(Fns);
        taA.setEditable(false);

        ScrollPane t = new ScrollPane();
        t.add(taA);
        deck.add(t, "text");

        add(deck, "Center");

	canA.addMouseListener(this);
        canA.addMouseMotionListener(this);
    }
    public void start() {
	W = getCanvasD().width;
        H = getCanvasD().height;
	canA.setSize(W, H);
	ig = createImage(W, H);

	init_data();
    }
    public void init_data() {
	Hsft = H-FNT*3;
	H2 = Hsft/2;
	Xby = 2;
	Yby = Hsft/(double)Short.MAX_VALUE/50;
	Wby = H2/(double)Short.MAX_VALUE;
	Cby = 1;
	CX = 50.0;
	Cmax = 50; // diff˻
	ValIH = 30; // 1/10
	Level = (int)(Hsft*9/10d);
	KEY = 49-1;
	Error = "";

	CP = new CalcPitch();
	set_nn();
	set_scrKey();
	enable_set();
	if (isFile())
	    select_file();
    }
    public Dimension getCanvasD() {
        Dimension dn = Pn.getSize();
	Dimension ds = Ps.getSize();
        Dimension de = Pe.getSize();
	Dimension dw = Pw.getSize();
	Dimension da = getSize();
        int cw = da.width-(de.width+dw.width);
        int ch = da.height-(dn.height+ds.height)-6;
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public void select_file() {
	read_file(chFile.getSelectedItem());
    }
    public void read_file(String fn) {
	if (!isFile())
	    return;

	setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR)); // 
	read_data(Dirnm+fn);

	if (!Error.equals(""))
	    tfA.setText(Error);
	else {
	    Start = 0;
	    Cnt = WaveDataN;
	    averge();

	    Sph = Splngf/2;
	    Ymax = 0;
	    CP.initPitch(Wdat, Splngf, NN, get_devid(),
			 Cnt, Start, calc_level(), Cmax);
	    CP.reset_peak();
	    set_devid();
	}
	IHsw = false;

	setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    }
    public boolean isFile() {
	return (AF > 0);
    }
    public void enable_set() {
	boolean go = (thr == null);
	boolean gw = (GRAP == WAVE);
	boolean gf = (GRAP == FFT_);
	scrWide.setEnabled((gf || gw) && go);

	boolean gr = (GRAP == INHA);
	btCX.setEnabled(gr && go); // x2
	btCZ.setEnabled(gr && go); // /2

	boolean gt = (!GTsw);
	btW.setEnabled(!(!go && gw) && gt); // >
	btN.setEnabled(!(!go && gw) && gt); // <

	boolean gp = (GRAP == PEAK);
	boolean gc = (GRAP == CENT);
	scrKey.setEnabled(gp || gf || (gr && AutoSW));
	btP.setEnabled((gw || gc || gr || (gf && go)) && gt); // +
	btM.setEnabled((gw || gc || gr || (gf && go)) && gt); // -

	boolean gd = (GRAP == DIFF);
	scrVert.setEnabled((gp || gf || gr || gd) && go);
    }
    public void set_nn() {
	NN = (int)Math.pow(2, NB);
	N2 = NN/2;
	PeakLimit = 0;

	CP.setSample(NN, get_devid());
	CP.reset_peak();
	set_devid();
    }
    public void set_count() {
	set_scrWave();

	if (CP != null) {
	    CP.setWide(Start, Cnt);
	    set_devid();
	    CP.reset_peak();
	}

	CALC = false;
    }
    public void mouseMoved(MouseEvent m) {
	if (!GTsw && Msw) { // not TEXT
	    if (GRAP != WAVE) { // waveʳ
		MX = m.getX();
		KEY = CP.ftok(MX/Wdf);
		IHsw = false; // calc. multiple

		if (AutoSW) // manu. not auto
		    scrKey.setValue(KEY);

		canA.repaint();
	    }
	}
    }
    public void mousePressed(MouseEvent m) { 
	if (!GTsw) { // not TEXT
	    switch (GRAP) {
	    case FFT_:
		Lastp = Firstp = get_fft_number(m.getX());
		CP.resetPower(); // ǽreset
                break;
	    case PEAK:
	    case INHA:
	    case CENT:
		Msw = !Msw;
		MX = m.getX();
		break;
	    case WAVE:
		Firstx = minmax_limit(m.getX());
		CALC = false;
		break;
	    default:
	    }
	    canA.repaint();
	}
    }
    public int minmax_limit(int gx) {
        if (gx > W)
            gx = W-1;
        if (gx < 0)
            gx = 0;

        return gx;
    }
    public void mouseReleased(MouseEvent m) {
	switch (GRAP) {
	case WAVE:
	    DragSW = false;
	    Lastx = minmax_limit(m.getX());
	    int wid = (int)(Math.abs(get_LFD()));
            if (wid > NN)
                selected();
	    else
		DragSW = false;
	    canA.repaint();
	    set_count();
	    break;
	case FFT_:
	    Lastp = get_fft_number(m.getX());
            if (isFftNotDragged())
                Msw = !Msw;

            select_power();
            if (Lastp-Firstp < 1)
                reset_power(); // ϰ0reset
            else
                set_power();
            
            canA.repaint();
	    break;
	default:
	}
    }
    public int get_fft_number(int gx) {
        int mx = (int)(gx/Wdn);
        if (mx > N2)
            mx = N2-1;
        if (mx < 0)
            mx = 0;

        return mx; 
    }
    public void select_power() {
        if (Lastp < Firstp) {
            int x = Lastp;
            Lastp = Firstp;
            Firstp = x;
        }
    }
    public void set_power() {
        for (int i = Firstp; i < Lastp; i++)
            CP.setPower(i);
    }
    public void reset_power() {
        CP.resetPower();
    }
    public boolean isFftNotDragged() {
        return (Lastp == Firstp);
    }
    public void mouseDragged(MouseEvent m) {
	switch (GRAP) {
	case WAVE:
            DragSW = true;
	    Lastx = minmax_limit(m.getX());

            canA.repaint();
	    break;
	case FFT_:
	    Lastp = get_fft_number(m.getX());

            canA.repaint();
            break;
        default:
        }
    }
    public void mouseEntered(MouseEvent m) { }
    public void mouseExited (MouseEvent m) { }
    public void mouseClicked(MouseEvent m) { }
    public void selected() {
        if (Lastx < Firstx) {
            int x = Lastx;
            Lastx = Firstx;
            Firstx = x;
        }
        Start += (int)(Firstx/Dwave);
	Cnt = (int)get_LFD();

	set_count();
    }
    public double get_LFD() {
	return (Lastx-Firstx)/Dwave;
    }
    public void adjustmentValueChanged(AdjustmentEvent e) {
	if (e.getSource() == scrWide) {
	    Start = scrWide.getValue();
	    set_count();
	}
	if (e.getSource() == scrVert) {
	    switch (GRAP) {
	    case FFT_:
		Level = scrVert.getValue();
		CP.setLevel(calc_level());
		CALC = false;
		break;
	    case PEAK:
		PeakLimit = scrVert.getValue();
		break;
	    case INHA:
	    case DIFF:
		ValIH = scrVert.getValue();
		break;
	    default:
	    }
	}
	if (e.getSource() == scrKey) {
	    if (GRAP != WAVE) { // waveʳ
		KEY = scrKey.getValue();
		IHsw = false;
	    }
	}

	disp_sw();
    }
    public double getValueInh() {
	return ValIH/10.0;
    }
    public void set_scrollbar() {
	switch (GRAP) {
	case FFT_:
	    scrVert.setValues(Level, 1, 1, Hsft);
	    scrVert.setBlockIncrement((int)(Level/10d));
	    scrVert.setUnitIncrement((int)(Level/100d));
	    break;
	case PEAK:
	    scrVert.setValues(PeakLimit, 1, 0, CP.getFrame());
	    scrVert.setBlockIncrement(2);
	    scrVert.setUnitIncrement(1);
	    break;
	case INHA:
	case DIFF:
	    scrVert.setValues(ValIH, 1, MinIH, MaxIH+1);
	    scrVert.setBlockIncrement(10);
	    scrVert.setUnitIncrement(1);
	    break;
	default:
	}
    }
    public void set_scrWave() {
	scrWide.setValues(Start, Cnt, 0, WaveDataN);
	scrWide.setBlockIncrement(NN/2);
	scrWide.setUnitIncrement(NN/10);
    }
    public void set_scrKey() {
	scrKey.setValues(KEY, 1, 0, KB);
	scrKey.setBlockIncrement(Oct);
	scrKey.setUnitIncrement(1);
    }
    public void actionPerformed(ActionEvent e) {
	if (e.getSource() == btM)       // -
            set_val(false);
        else if (e.getSource() == btP)  // +
            set_val(true);

	else if (e.getSource() == btW)  // max.f /2
            set_wide(false);
        else if (e.getSource() == btN)  // max.f x2
            set_wide(true);

	else if (e.getSource() == btGO) // go
	    set_go();

	else if (e.getSource() == btGrap[WAVE]) {
	    GRAP = WAVE;
	    set_wave_button();
	} else if (e.getSource() == btGrap[FFT_]) {
	    GRAP = FFT_;
	    set_fft_button();
	} else if (e.getSource() == btGrap[PEAK]) {
	    GRAP = (GRAP == PEAK) ? CENT : PEAK;
	    set_peak_button();
	}
	else if (e.getSource() == btGrap[INHA]) {
	    GRAP = (GRAP == INHA) ? DIFF : INHA;
	    set_inha_button();
	}
	else if (e.getSource() == btTX) // graph./text
	    set_grap();

	else if (e.getSource() == btCX) // cent x 
	    cent_by(true);
	else if (e.getSource() == btCZ) // cent / 
	    cent_by(false);

	else if (e.getSource() == btAuto)
	    set_auto();

	set_scrollbar();
	enable_set();
	disp_sw();
    }
    public void set_wave_button() {
	WaveCnt++;
	if (WaveCnt > 1) {
	    WaveSW = !WaveSW;
	    WaveCnt = 0;
	}
	resetFFT_button();
    }
    public void set_fft_button() {
	FftCnt++;
	if (FftCnt > 1) {
	    FftSW = !FftSW;
	    FftCnt = 0;
	}
	resetWave_button();
    }
    public void set_inha_button() {
	btGrap[INHA].setLabel((GRAP == INHA) ? "Inha." : "(diff)");
	resetFFT_button();
	resetWave_button();
    }
    public void set_peak_button() {
	btGrap[PEAK].setLabel((GRAP == PEAK) ? "Peak." : "(cent)");
	resetFFT_button();
	resetWave_button();
    }
    public void resetFFT_button() {
	FftCnt = 0;
    }
    public void resetWave_button() {
	WaveCnt = 0;
    }
    public void set_grap() {
	GTsw = !GTsw;
	btTX.setLabel(GTsw ? "Text" : "Grap.");
	Card.next(deck);
    }
    public void set_go() {
	if (!isFile())
	    return;

	if (thr == null) {
	    CP.startRun();
	    set_go_button(false);

	    thr = new Thread(this);
	    thr.start();
	} else {
	    CP.stop();
	    set_go_button(true);
	    thr = null;
	}	
    }
    public void set_go_button(boolean sw) {
	btGO.setLabel(sw ? " GO " : "Stop");
    }
    public void set_auto() {
	AutoSW = !AutoSW;
	btAuto.setLabel(AutoSW ? "Manu." : "Auto.");

	IHsw = false; // ؤǺƷ׻Ԥ
    }
    public void cent_by(boolean sw) {
	int min = 25;
	int max = 400;

	CX = sw ? CX*2 : CX/2;
	if (CX > max)
	    CX = min;
	else if (CX < min)
	    CX = max;
    }
    public void set_val(boolean sw) {
	switch (GRAP) {
	case WAVE:
	    Wby = sw ? Wby*2 : Wby/2;
	    break;
	case INHA:
	    int min = 10;
	    int max = 100;
	    int dc = 10;

	    Cmax = sw ? Cmax+dc : Cmax-dc;
	    if (Cmax > max)
		Cmax = min;
	    else if (Cmax < min)
		Cmax = max;

	    CP.setCmax(Cmax);
	    IHsw = false;
	    break;
	case FFT_:
	    double sq = Math.sqrt(2);
	    Yby = sw ? Yby*sq : Yby/sq;
	    CP.setLevel(calc_level());
	    break;
	case CENT:
	    Cby = sw ? Cby*2 : Cby/2;
	    break;
	default:
	}
    }
    public void set_wide(boolean sw) {
	switch (GRAP) {
	case WAVE:
	    Cnt = sw ? Cnt/2 : Cnt*2;
	    if (Cnt < NN)
		Cnt = NN;
	    else if (Cnt > WaveDataN) {
		Cnt = WaveDataN;
		Start = 0;
	    }
	    if (Start+Cnt > WaveDataN)
		Start = WaveDataN-Cnt;

	    set_count();
	    break;
	case FFT_:
	case PEAK:
	case INHA:
	case CENT:
	    int min = 1;
	    int max = 512;

	    Xby = sw ? Xby/2 : Xby*2;
	    if (Xby < min)
		Xby = min;
	    else if (Xby > max)
		Xby = max;
	    break;
	default:
	}
    }
    public void set_devid() {
	CP.setDevid(get_devid());

        CALC = false;
    }
    public int get_devid() {
	return chDevid.getSelectedIndex(); // 0~4
    }
    public void itemStateChanged(ItemEvent e) {
        if (e.getSource() == chFile)    // choice file
	    select_file();
	
	if (e.getSource() == chSmpl) {  // sampling    
	    NB = Integer.parseInt(chSmpl.getSelectedItem());
	    set_nn();
	}

	if (e.getSource() == chDevid)
	    set_devid();

	disp_sw();
    }
    public void run() {
        int stime = 10;
        Error = "";
        CALC = false;

        setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR)); // 
	run_set_enable(false);
        try {
            while (CP.isRun()) {
                disp_sw();
                thr.sleep(stime);
            }
        } catch (InterruptedException e) {
            Error = "Run error.";
            // System.out.println(e);
        }
        setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	run_set_enable(true);
	set_go_button(true);

        thr = null;
        disp_sw();

        Error = (CP.getError() == null) ? Error : CP.getError();
        CALC = true;
        IHsw = false;
    }
    public void stop() {
        if (thr != null)
            thr = null;
    }
    public void run_set_enable(boolean sw) {
	chFile.setEnabled(sw);
	chDevid.setEnabled(sw);
	chSmpl.setEnabled(sw);
	scrWide.setEnabled(sw);
	scrVert.setEnabled(sw);
	btP.setEnabled(sw);
	btM.setEnabled(sw);
	btCX.setEnabled(sw);
	btCZ.setEnabled(sw);
	btN.setEnabled(sw);
	btW.setEnabled(sw);
    }
    public void calc_() {
        if (!isFile())
            return;

	CP.calc_one_time();
        CALC = true;
        IHsw = false;
    }
    public void disp_sw() {
	if (GTsw)
	    re_write();     // text
	else 
	    canA.repaint();  // graph.
    }
    public void write_error() {
	tfA.setText(Error.equals("") ? "" : Error);
    }
    public String dform(double val) {
	return df1.format((float)val);
    }
    public String dform2(double val) {
	return df2.format((float)val);
    }
    //--------

    public void re_write() {
	write_error();

	switch (GRAP) {
	case WAVE:
	    write_wave();
	    break;
	case FFT_:
	    write_peak();
	    break;
	case PEAK:
	    write_pitch();
	    break;
	case INHA:
	    if (isFile())
		write_partial();
	    break;
	case DIFF:
	    write_diff();
	    break;
	case CENT:
	    write_cent();
	    break;
	default:
	}
    }
    public void write_wave() {
	StringBuffer str = new StringBuffer(1024);
	str.append("DataType : Channel : BlockSize : SamplingF : DataSize\n");
	str.append("-----------------------------------------------------\n");
	str.append(AFormat);

	taA.setText(str.toString());
    }
    public void write_peak() {
	StringBuffer str = new StringBuffer(1024);
	if (!CALC)
	    calc_();
	str.append(loop_());
	str.append(head_());
	for (int i = 0; i < CP.getALsize(); i++) {
	    str.append((i+1)+": ");
	    str.append(CP.getPeaksf(i)+"\n");	    
	}

	taA.setText(str.toString());
    }
    public String loop_() {
	StringBuffer str = new StringBuffer(256);
	str.append("Count:["+CP.getLoop()+"]/");
	str.append(CP.getFrame()+"\n");

	return str.toString();
    }
    public String head_() {
	StringBuffer str = new StringBuffer(1024);
	str.append("Sampling f."+Splngf);
	str.append(": Data num."+(CP.getLoop()*NN)+"/"+Cnt);
	str.append(": Sampl num."+NN+"\n");
	str.append("#: [Hz] Key#:  peak>");
	str.append(dform(calc_level())+"(max:");
	str.append(dform(CP.getYmax())+")\n");
	str.append("------------------------------------\n");

	return str.toString();
    }

    public void write_pitch() {
	if (!isFile())
	    return;
	if (!CALC)
	    calc_();

	StringBuffer str = new StringBuffer(1024);
   	str.append("["+PeakLimit+"]/");
	str.append((CP.getFrame())+"\n");
	str.append("#: Key#: count:  [Hz]\n");
	str.append("---------------------------\n");
	for (int i = 0; i < CP.getPitch(0).getPcounter(); i++) {
	    if (CP.getPitch(i) == null)
		continue;
	    if (CP.getPitch(i).getPcount() >= PeakLimit) {
		str.append((i+1)+": ");
		str.append(CP.getPitch(i)+"\n");
	    }
	}

	taA.setText(str.toString());
    }
    public void write_partial() {
	if (!CALC)
	    calc_();
	if (!IHsw) {
	    CP.calcInharmo(KEY, getValueInh(), AutoSW);
	    IHsw = true;
	}
	StringBuffer str = new StringBuffer(1024);
	String bar = "-------------------------------------------------\n";
	str.append("P#: Key#[count]:  [Hz]: c.equal: c.pure: I.const.\n");
	str.append(bar);

	int n = CP.getICount();
	if (n > 0) {
	    for (int i = 0; i < n; i++)
		str.append(write_inh(i));
	}
	str.append(bar);
	str.append(" ["+get_ip(n)+"]");
		
	taA.setText(str.toString());
    }
    public String write_inh(int n) {
	StringBuffer s = new StringBuffer(48);

	int pn = CP.getMultiple(n).getMulti();
	s.append((pn+1)+": ");
	s.append(CP.getMultiple(n).getPitch()+": ");
	s.append(dform(CP.getECent(n))+": "); // NullPointerException ?
	s.append(dform(CP.getICent(n))+": ");
	s.append((pn == 0) ? "---" : dform(CP.getInharmo(n))).append("\n");

	return s.toString();
    }
    public void write_diff() {
	if (CP.getMinSum() == null)
	    return;

	StringBuffer s = new StringBuffer(48);
	int lensum = CP.getSumCount();
	double[] data = CP.getMinSum();
	double maxsum = CP.getMaxSum();
	for (int i = 0; i < lensum; i++) {
	    s.append(i+": ");
	    s.append(dform(data[i])+"\n");
	}
	s.append("-------------\n");
	s.append("diff_max:"+dform(maxsum));

	taA.setText(s.toString());
    }
    public void write_cent() {
	int inh = CP.getICount();

	if (inh > 0)
	    write_inha_cent(inh);
	else
	    write_peak_cent();
    }
    public void write_peak_cent() {
	StringBuffer s = new StringBuffer(48);

	int k, c, c0 = 0;
	double f, ce;
	s.append("key:[cent]...\n");
	s.append("---------------------------\n");
	for (int i = 0; i < CP.getALsize(); i++) {
	    c = CP.getPeaksc(i);
	    if (c != c0)
		s.append("\n");
	    k = CP.getPeaksk(i);
	    f = CP.getPeaksf(i);
	    ce = CP.ftoc(k, f);    // centͤ
	    s.append(k+":");
	    s.append(dform(ce)+"\n");
	    c0 = c;
	}

	taA.setText(s.toString());
    }
    public void write_inha_cent(int n) {
	StringBuffer s = new StringBuffer(48);
	int keym, key, mul, kp, cn;
	double f, ce;
	boolean debug = false; // for octave

	s.append("#: Key[count]: [Hz]: [cent]...\n");
	s.append("------------------------------\n");
	for (int k = 0; k < n; k++) {
	    key = CP.getMultiple(k).getPkey();  // ܲΤ륭
	    mul = CP.getMultiple(k).getMulti(); // ܲ

	    if (debug) {
		s.append((mul+1)+" ");
		s.append((key+1)+" ");
	    } else {
		s.append((mul+1)+": ");
		s.append(CP.getMultiple(k).getPitch()+": ");
	    }

	    for (int i = 0; i < CP.getALsize(); i++) {
		kp = CP.getPeaksk(i);
		cn = CP.getPeaksc(i);
		if (kp == key) {
		    keym = CP.getMultiple(k).getKey();  // ܲθΥ
		    f = CP.getPeaksf(i);
		    ce = CP.ftoc(keym, f)+CP.getLadder(mul); // keym
		    s.append(dform(ce)+" ");
		}
	    }
	    s.append("\n");
	}

	taA.setText(s.toString());
    }
    public String get_ip(int n) {
	StringBuffer str = new StringBuffer(40);
	if (n > 0)
	    str.append("Pitch:"+dform(CP.getLsmA()));
	if (n > 1) {
	    str.append(" Inharmo.:"+dform(CP.getLsmB()));
	    str.append(" ("+dform(CP.getLsmR())+")");
	} else
	    str.append("...");

	return str.toString();
    }
    //---
 
    class MyCanvas extends Canvas {
	private static final long serialVersionUID = 1L;

	public void update(Graphics g) {
	    canA.paint(g);
	}
	public void paint(Graphics g) {
	    gi = ig.getGraphics();
	    paintI();
	    g.drawImage(ig, 0, 0, this);
	}
    }
    private final Color darkMagenta = new Color(180, 0, 150);
    private final Color darkGreen = new Color(80, 228, 80);    
    private final Color darkBlue = new Color(80, 80, 228);
    private final Color darkRed = new Color(230, 30, 30);
    private final Color Violet = new Color(90, 120, 160);
    private final Color Bar = new Color(64, 128, 255);

    private int W = 400;       // canvas w 391
    private int H = 280;       //  "    
    private int H2;            // Hsft/2
    private int Hsft;          // 

    public void paintI() {
	Wdf = W/(double)(Sph/Xby);
	Wdn = W/(double)(N2/Xby);
	Vsize  = Hsft/(double)CP.getFrame();

	disp_black(gi);
	write_error();

	switch (GRAP) {
	case WAVE:
	    disp_wave(gi);
	    break;
	case FFT_:
	    disp_rule(gi);
	    disp_fft(gi);
	    disp_key(gi);
	    break;
	case PEAK:
	    disp_rule(gi);
	    disp_peak(gi);
	    disp_key(gi);
	    break;
	case INHA:
	    disp_rule(gi);
	    disp_pitch(gi);
	    disp_inhar(gi);
	    disp_key(gi);
	    break;
	case DIFF:
	    disp_minsum(gi);
	    break;
	case CENT:
	    disp_rule(gi);
	    disp_cent(gi);
	    disp_key(gi);
	    break;
	default:
	}

	//showStatus(" alltime: "+(float)(Cnt/(double)Splngf)+
	//   " CP.getDevidTime: "+(float)CP.getDevidTime());
    }
    public void disp_key(Graphics g) {
	if (!isFile())
	    return;
	int key = get_key();
	g.setColor(Color.red);
	g.fillRect((int)(CP.getFreq(key)*Wdf), Hsft, (int)(Wdn+1), 4);
    }
    public int get_key() {
	return AutoSW ? KEY : CP.getFundKey();
    }
    public void disp_black(Graphics g) {
	g.setColor(Color.black);
	g.fillRect(0, 0, W, H);
    }
    public void disp_wave(Graphics g) {
	g.setColor(Color.gray);
	g.drawLine(0, H2, W, H2);   // center line
	g.drawLine(0, Hsft, W, Hsft); // bass line

	if (!isFile())
	    return;

	Dwave = W/(double)Cnt;
	int val, max = Integer.MIN_VALUE, min = Integer.MAX_VALUE;
	int x0, y0, x1 = 0, y1 = 0;
	g.setColor(Color.green);
	for (int i = 0; i < Cnt; i++) {
	    val = Wdat[i+Start];
	    x0 = (int)(Dwave*i);
	    y0 = (int)(H2-val*Wby);
	    if (i == 0) {
		x1 = x0;
		y1 = y0;
	    }
	    g.drawLine(x0, y0, x1, y1);
	    x1 = x0;
	    y1 = y0;
	    max = Math.max(max, val);
	    min = Math.min(min, val);
	}

	disp_time(g);
	disp_nn_wide(g);
	if (!WaveSW)
	    disp_wave_value(g, min, max);
	write_text(0);
	if (DragSW)
            disp_cursor(g);
    }
    public void disp_cursor(Graphics g) {
	if (Math.abs(get_LFD()) < NN)
	    g.setColor(Color.red);
	else
	    g.setColor(Bar);
        g.drawLine(Firstx, 0, Firstx, H);
        g.drawLine(Lastx, 0, Lastx, H);
    }
    public void disp_nn_wide(Graphics g) {
	int h = 2;
	double dn = Dwave*NN;
	double wsize = W/(double)CP.getFrame();
	g.setColor(Color.orange);
	g.drawRect((int)(wsize*CP.getLoop()), Hsft-1, (int)dn, h);
    }
    public void disp_wave_value(Graphics g, int min, int max) {
	g.setColor(Color.lightGray);
	g.drawString(dform2(100*max/SMaxVal), 1, (int)(H2-max*Wby));
	g.drawString(dform2(100*min/SMaxVal), 1, (int)(H2-min*Wby+FNT));
	g.drawString("[%]", 1, FNT);
    }
    public void disp_time(Graphics g) {
	double allsec = Cnt/(double)Splngf;
	double tim = get_tim(allsec);

	String s = "[sec] ";
	g.setColor(Color.yellow);
	g.drawString(s, W-fm.stringWidth(s), H-FNT*2);

	double asec = tim/(allsec/W);
	int maxsec = (int)(allsec/tim);
	if (maxsec > 0) {
	    int ss = H-FNT;  // ʸh
	    int x, l = 5;
	    for (int i = 0; i <= maxsec; i++) {
		x = (int)(asec*i);

		g.setColor(Color.gray);
		g.drawLine(x, Hsft, x, Hsft+l);

		g.setColor(Color.yellow);
		g.drawString(dform(i*tim), x, ss);
	    }
	}
    }
    public void disp_vtime(Graphics g) {
	double allsec = CP.getDevidTime();
	double tim = get_tim(allsec);

	String s = "[sec] ";
	g.setColor(Color.yellow);
	g.drawString(s, W-fm.stringWidth(s), H);

	double asec = tim/(allsec/Hsft);
	int maxsec = (int)(allsec/tim);
	if (maxsec > 0) {
	    int ss = W-30;  // ʸx
	    int y, l = 5;
	    for (int i = 0; i <= maxsec; i++) {
		y = (int)(asec*i);

		g.setColor(Color.gray);
		g.drawLine(W, y, W-l, y);

		g.setColor(Color.yellow);
		g.drawString(dform(i*tim), ss, y+FNT);
	    }
	}
    }
    public double get_tim(double allsec) {
	double tim;

	if (allsec < 0.1)
	    tim = 0.01;
	else if (allsec < 0.3)
	    tim = 0.05;
	else if (allsec < 1)
	    tim = 0.1;
	else if (allsec < 3)
	    tim = 0.5;
	else if (allsec < 10)
	    tim = 1;
	else if (allsec < 30)
	    tim = 5;
	else if (allsec < 60)
	    tim = 10;
	else
            tim = 60;

	return tim;
    }
    public void write_text(int n) {
	if (!Error.equals(""))
	    return;
	if (n < 0)
	    return;

	StringBuffer and = new StringBuffer(32);
	switch(GRAP) {
	case WAVE:
	    and.append(Cnt+"/"+WaveDataN);
	    and.append(" ["+NN+"]:"+NB);
	    break;
	case FFT_:
	    and.append(dform(MX/Wdf)+"[Hz]:");
	    and.append(dform(CP.getPower(n)));
	    break;
	case PEAK:
	    and.append((n+1)+":");
	    and.append(CP.getPitch(n)+"[Hz]");
	    break;
	case INHA:
	    and.append(get_keyname(get_key())+" ");
	    and.append(get_ip(n));
	    break;
	case DIFF:
	    if (CP.getMinSum() == null)
		return;
	    and.append("max:"+dform(CP.getMaxSum()));
	    and.append(" inha.:"+dform(CP.getINH())); // CP.getLsmB()ǤϤʤ
	    and.append(" #:"+n);
	    break;
	default:
	}

	tfA.setText(and.toString());
    }
    public String get_keyname(int key) {
	return (key < 0) ? "" : (key+1)+Keynm[key%Oct];
    }   
    public void disp_rule(Graphics g) {
	int mej, dx, max = Sph/Xby;

	for (int i = 0; i <= max; i += 10) { // ȿ
	    if (i%10000 == 0) {
		mej = 20;
		if (max >= 10000)
		    disp_k(g, i);
	    } else if (i%5000 == 0) {
		mej = 17;
		if (max >= 5000)
                    disp_k(g, i);
	    } else if (i%1000 == 0) {
		mej = 14;
		if (max < 12000)
                    disp_k(g, i);
	    } else if (i%500 == 0) {
		if (max > 23000)
		    continue;
		mej = 11;
	    } else if (i%100 == 0) {
		if (max > 12000)
		    continue;
		mej = 8;
	    } else if (i%50 == 0) {
		if (max > 4000)
		    continue;
		mej = 5;
	    } else if (i%10 == 0) {
		if (max > 2000)
		    continue;
		mej = 2;
	    } else
		continue;

	    dx = calc_dx(i);
	    g.setColor(Color.gray);
	    g.drawLine(dx, Hsft, dx, Hsft+mej);
	} 
	
	g.setColor(Color.gray);
	g.drawLine(0, Hsft, W, Hsft);
    }
    public int calc_dx(int i) {
	return (int)(i*Wdf);
    }
    public void disp_k(Graphics g, int k) {
        g.setColor(Color.pink);
        g.drawString(k/1000+"k", calc_dx(k), H-FNT);
    }
    public void disp_fft_cursor(Graphics g) {
	if (isFftNotDragged())
	    return;

	int fp = get_fft2freq(Firstp);
	int lp = get_fft2freq(Lastp);

	g.setColor(Color.white);
	g.drawLine(fp, 0, fp, H);
	g.drawLine(lp, 0, lp, H);
    }
    public void disp_fft_max(Graphics g) {
	int xf = (int)(Wdn*CP.getMaxf());

	g.setColor(Color.yellow);
	g.fillRect(xf, Hsft, (int)(Wdn+1), 6);
    }
    public int get_fft2freq(int p) {
	return (int)(p*Wdn);
    }
    public void disp_fft(Graphics g) { 
	disp_fft_memori(g);

	if (!isFile())
	    return;
	if (!CALC)
	    calc_();

	g.setColor(darkMagenta);
	g.drawLine(0, Level, W, Level); // ԡ

	int mxf = CP.getMaxf();
	int v1, x1, v0 = 0, x0 = 0;
	for (int i = 0; i < N2/Xby; i++) {
	    v1 = (int)(CP.getPower(i)*Yby);
	    x1 = (int)(Wdn*i);
	    if (CP.isPower(i))
		g.setColor(Color.white);
	    else if (MX >= x1 && MX < x1+Wdn) {
		write_text(i);
		g.setColor(Color.pink);
	    } else if (i == mxf)
		g.setColor(Color.yellow);
	    else
		g.setColor(darkGreen);

	    if (i == 0) {
		v0 = v1;
		x0 = x1;
	    }
	    if (FftSW)
		g.drawLine(x0, Hsft-v0, x1, Hsft-v1);
	    else
		g.drawRect(x1, Hsft-v1, (int)Wdn, v1);
	    v0 = v1;
	    x0 = x1;
	}
	disp_fft_cursor(g);
	disp_fft_max(g);
    }
    public void disp_fft_memori(Graphics g) {
	int hi, num = 10, mw = fm.stringWidth("10");
	double hd = Hsft/(double)num;

	for (int i = 1; i <= num; i++) {  // memori
	    hi = (int)(Hsft-hd*i);

	    g.setColor(darkBlue);
	    g.drawLine(0, hi, W, hi);
 
	    g.setColor(darkRed);
	    g.drawString(""+i, W-mw, hi+FNT);
	}
    }
    public int calc_level() {
       	return (int)((Hsft-Level)/Yby);
    }
    public int search_pkdata() {
	int max = CP.getPnum();
	int p = -1;
	for (int i = 0; i < max; i++) {
	    if (CP.getPitch(i) == null)
		break;
	    if (KEY == CP.getPitch(i).getPkey())
		p = i;
	}
	write_text(p);

	return p;
    }
    public void disp_peak(Graphics g) {
	disp_devid(g);

	if (!isFile())
	    return;
	if (!CALC)
	    calc_();
	int y, k, xk = -1, n = search_pkdata();
	if (n >= 0)
	    xk = CP.getPitch(n).getPkey();
	for (int i = 0; i < CP.getALsize(); i++) {
	    y = (int)(Vsize*CP.getPeaksc(i));
	    k = CP.getPeaksk(i);
	    g.setColor((xk >= 0 && k == xk) ?
		       Color.pink : darkGreen);
	    g.drawRect((int)(CP.getPeaksf(i)*Wdf), y,
		       (int)(Wdn+1), (int)Vsize);
	}

	disp_vtime(g);
    }
    public void disp_pitch(Graphics g) {
	if (!isFile())
	    return;
	if (!CALC)
	    calc_();

	double iv;
	g.setColor(Violet);
	for (int i = 0; i < CP.getPitch(0).getPcounter(); i++) {
	    if (CP.getPitch(i) == null)
		continue;
	    iv = CP.getPitch(i).getPcount()*Vsize;

	    g.drawRect((int)(CP.getPitch(i).getPfreq()*Wdf),
		       (int)(Hsft-iv), (int)(Wdn+1), (int)iv);
	}
    }
    public void disp_devid(Graphics g) {
	int hi;

	g.setColor(Color.gray);
	for (int i = 0; i <= CP.getFrame(); i++) { // memori
	    hi = (int)(Vsize*i);
	    g.drawLine(0, hi, 5, hi);
	}
    }
    public void disp_inhar(Graphics g) {
	int hs = Hsft/2;
	double hd = hs/CX;
	disp_devid(g);
	cent_rule(g, hs, hd);

	if (!isFile())
	    return;
	if (!CALC)
	    calc_();
	if (!IHsw) {
	    CP.calcInharmo(KEY, getValueInh(), AutoSW);
	    IHsw = true;
	}

	int n = CP.getICount();
	if (n > 0) {
	    int mx = CP.getMultiple(n-1).getMulti(); // ܲ
	    disp_lsm(g, hs, mx, hd);

	    int wd = (int)(Wdn+1);
	    int sr = 2;    // Υɥå
	    int sd = sr*2; // "   ľ
	    int d2 = 2;    // ⤵1/2
	    int dh = d2*2; // ⤵
	    int x0 = 0, y0 = 0, x1, y1;

	    g.setColor(darkBlue);
	    for (int i = 0; i < n; i++) {
		x1 = (int)(CP.getMultiple(i).getPfreq()*Wdf);
		y1 = (int)(CP.getICent(i)*hd); // c.pure
		if (i == 0) {
		    x0 = x1;
		    y0 = y1;
		}
		g.setColor(darkBlue);      // ľ
		g.drawLine((int)(x0+Wdn), hs-y0, x1, hs-y1);

		g.setColor(Color.magenta); // .
		g.fillRect(x1, hs-y1-d2, wd, dh);
		x0 = x1;
		y0 = y1;
	    }
	}
	write_text(n);
    }
    public void disp_lsm(Graphics g, int hs, int mx, double hd) {
	int x0, y0, x1 = 0, y1 = 0, ii;
	int k = get_key();
	double f = CP.getFreq(k); // 

	g.setColor(Color.gray);
	for (int i = 0; i < mx+1; i++) {
	    ii = i+1;
	    x0 = (int)(CP.getIfreq(f, ii)*Wdf);
	    y0 = (int)(CP.calcLSM(ii)*hd);
	    if (i == 0) {
		x1 = x0;
		y1 = y0;
	    }
	    g.drawLine(x1, hs-y1, x0, hs-y0);
	    x1 = x0;
	    y1 = y0;
	}
    }
    public void disp_minsum(Graphics g) {
	int starti = (int)(CP.getStartIH()*10);
	diff_rule(g, starti);
	if (CP.getMinSum() == null)
	    return;

	int lensum = CP.getSumCount();  // ǡ
	double[] data = CP.getMinSum(); // Υǡ
	double maxsum = CP.getMaxSum(); // κ
	int num = (-starti+ValIH)*10; // max(7.0/0.01) 

	int x, y, x0 = 0, y0 = 0;
	double dw = W/(double)num;
	double dh = Hsft/maxsum;

	g.setColor(Color.lightGray);
	for (int i = 0; i < num; i++) {
	    x = (int)(dw*i);
	    if (i > lensum)
		continue;
	    y = (int)(Hsft-dh*data[i]);
	    if (i == 0) {
		x0 = x;
		y0 = y;
	    }
	    g.drawLine(x0, y0, x, y);
	    x0 = x;
	    y0 = y;
	}

	disp_maxsum(g, maxsum);
	write_text(lensum);
    }
    public void disp_maxsum(Graphics g, double max) {
	String s = "max:"+dform(max);
	g.setColor(Color.red);
	g.drawString(s, W-fm.stringWidth(s), FNT);
    }
    public void diff_rule(Graphics g, int start) {
	g.setColor(Color.gray);
	g.drawLine(0, Hsft, W, Hsft);

	int l, ix, ii = 0;
	double dx = W/(double)(ValIH-start);  // -ʤΤ+

	for (int i = start; i < ValIH; i++) { // -ʤΤǤΤޤ 
	    ix = (int)(dx*ii++);

	    if (i % 10 == 0) { // 1.0
		l = 12;
		g.setColor(Color.pink);
		g.drawString(dform(i/10.0), ix, H-FNT);
	    } else if (i % 5 == 0) { // 0.5
		l = 8;
	    } else // 0.1
		l = 6;

	    g.setColor(Color.gray);
	    g.drawLine(ix, Hsft, ix, Hsft+l);
	}
    }
    public void cent_rule(Graphics g, int hs, double hd) {
	g.setColor(Color.darkGray);   // center line
	g.drawLine(0, hs, W-1, hs);

	int mp, mm;
	double hi;
     	g.setColor(Color.lightGray);
	for (int i = 1; i < CX/10; i++) {  // cent memori
	    hi = hd*i*10;
	    mp = (int)(hs-hi);
	    mm = (int)(hs+hi);
	    g.drawLine(W-10, mp, W-1, mp);
	    g.drawLine(W-10, mm, W-1, mm);
	}

	int ch = (int)(CX*hd);
	String ps = ""+CX;
	String ms = "-"+CX;
	g.setColor(Color.orange);          // +-max
	g.drawString(ps, W-fm.stringWidth(ps), hs-ch+FNT);
	g.drawString(ms, W-fm.stringWidth(ms), hs+ch);

	g.setColor(Color.yellow);
	g.drawString("<"+Cmax, W-100, hs-ch+FNT);
    }
    public void disp_cent(Graphics g) {
	if (!CALC)
	    calc_();

	int inh = CP.getICount();
	if (inh > 0)
	    disp_inha_cent(g, inh);
	else
	    disp_peak_cent(g);
    }
    public void disp_peak_cent(Graphics g) {
	disp_cent_momori(g);

	double f, ce, fx;
	int y, k, w = (int)(Wdn+1), h0 = (int)Vsize;
	int h = (h0 > w) ? w : h0;

	int n = search_pkdata();  // 륭
	int xk = (n >= 0) ? CP.getPitch(n).getPkey() : -1;

	for (int i = 0; i < CP.getALsize(); i++) {
	    y = (int)(Vsize*CP.getPeaksc(i));
	    k = CP.getPeaksk(i);
	    f = CP.getPeaksf(i);
	    ce = CP.ftoc(k, f);     // c.equal
	    fx = CP.getFreq(k)*Wdf;

	    g.setColor(Color.gray);
	    g.drawLine((int)fx, y, (int)fx, y+h0);

	    g.setColor((xk >= 0 && k == xk) ?
		       Color.cyan : Color.yellow);
	    g.drawOval((int)(fx+ce*Cby), y, w, h);
	}
    }
    public void disp_inha_cent(Graphics g, int n) {
	disp_cent_momori(g);

	double f, ce, fx, y;
	int keym, key, kp, mul, c0;
	int w = (int)(Wdn+1), h0 = (int)Vsize;
	int h = (h0 > w) ? w : h0;

	int pk = search_pkdata();  // 륭
	int xk = (pk >= 0) ? CP.getPitch(pk).getPkey() : -1;

	for (int k = 0; k < n; k++) { // multiple
	    key = CP.getMultiple(k).getPkey();  // peakKey
	    for (int i = 0; i < CP.getALsize(); i++) {
		c0 = CP.getPeaksc(i);  // count
		y = Vsize*c0;
		kp = CP.getPeaksk(i);  // keynum
		if (kp == key) {
		    fx = CP.getFreq(key)*Wdf;
		    g.setColor(Color.gray);
		    g.drawLine((int)fx, (int)y, (int)fx, (int)(y+h0));

		    keym = CP.getMultiple(k).getKey();  // multiKey
		    mul = CP.getMultiple(k).getMulti(); // multiple
		    f = CP.getPeaksf(i);
		    ce = CP.ftoc(keym, f)+CP.getLadder(mul); // c.pure
		    g.setColor((xk >= 0 && key == xk) ?
 			       Color.cyan : Color.magenta);
		    g.drawOval((int)(fx+ce*Cby), (int)y, w, h);
		} // if
	    } // ALsize
	} // multi

	disp_vtime(g);
    }
    public void disp_cent_momori(Graphics g) {
	int x0, l = 8, max = 10;
	double dx = W/(double)max;

	String s = "|<"+(int)(W/Cby/max)+">|";
	g.setColor(Color.red);
	g.drawString(s, 1, H);

	g.setColor(Color.lightGray);
	for (int i = 0; i < max; i++) {
	    x0 = (int)(dx*i);
	    g.drawLine(x0, Hsft, x0, Hsft-l);
	}
    }
    //--------

    public void averge() {
	double sum = 0;

	for (int i = 0; i < WaveDataN; i++)
	    sum += Wdat[i];
	sum /= WaveDataN;
	for (int i = 0; i < WaveDataN; i++)
	    Wdat[i] = (int)(Wdat[i]-sum);
    }
    public void read_data(String fname) {
        try {
            URL url = new URL(getDocumentBase(), fname);
            ReadWave rw = new ReadWave(url);

    	    Wdat = rw.getData();
            Splngf = rw.getSamplf();
	    WaveDataN = rw.getCount();
	    String label = rw.getLabel();
            Error = rw.getError();
	    AFormat = rw.toString();

            tfA.setText(label+Splngf);
        } catch(Exception e) {
            Error = "File read error.";
        }
    }
}